include "basics/pts.ma".
include "connectives.ma".
include "leibniz.ma".
axiom nat : Type[0].
axiom S : nat -> nat.
axiom match_nat_type : \forall return_ : Type[0] . return_ -> (nat -> return_) -> nat -> return_.
axiom axiom_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (equal) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n).
definition eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) ((match_nat_type) (return_type) case_O case_S ((S)  n)) (case_S n) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((equal_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((axiom_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
definition sym_eq_match_nat_type_S : \forall return_type. \forall (case_O:return_type). \forall (case_S:nat -> return_type). \forall (n:nat). (leibniz) (return_type) (case_S n) ((match_nat_type) (return_type) case_O case_S ((S)  n)) := \lambda return_type : Type[0]. \lambda case_O : return_type. \lambda case_S : nat -> return_type. \lambda n : nat. ((((sym_leibniz) (return_type)) ((match_nat_type) (return_type) case_O case_S ((S)  n))) (case_S n)) (((((eq_match_nat_type_S) (return_type)) (case_O)) (case_S)) (n)).
definition not_zero : nat -> Prop := \lambda n : nat. (match_nat_type) (Prop) (False)  (\lambda p : nat. (True) ) n.
axiom le : nat -> nat -> Prop.
axiom le_ind : \forall (n:nat). \forall (Q:nat -> Prop). (Q n) -> (\forall (m:nat). ((le)  n m) -> (Q m) -> Q ((S)  m)) -> \forall (m:nat). ((le)  n m) -> Q m.
definition lt : nat -> nat -> Prop := \lambda n : nat. \lambda m : nat. (le)  ((S)  n) m.
definition lt_to_not_zero : \forall (n:nat). \forall (m:nat). ((lt)  n m) -> (not_zero)  m := \lambda n : nat. \lambda m : nat. \lambda Hlt : (lt)  n m. (((((((le_ind) ((S)  n)) (\lambda x_417 : nat. (not_zero)  x_417)) (((((((sym_eq_match_nat_type_S) (Prop)) ((False) )) (\lambda p : nat. (True) )) (n)) (\lambda y : Prop. y)) (I))) (\lambda m0 : nat. \lambda j_x_419 : (le)  ((S)  n) m0. (\lambda j_x_421 : (not_zero)  m0. (((((((sym_eq_match_nat_type_S) (Prop)) ((False) )) (\lambda p : nat. (True) )) (m0)) (\lambda y : Prop. y)) (I))))) (m)) (Hlt)).
